Subject: Re: [RFC] net: skbuff: let struct skb_ext live inside the head

From: Jakub Kicinski <[email-masked]>
Date: Wed, 15 Feb 2023 09:58:34 -0800

On Wed, 15 Feb 2023 09:53:54 +0100 Paolo Abeni wrote:
> Still, if you are willing to experiment more this idea, I think you
> could save the extra cacheline miss encoding the 'alloc_mode' into the
> lower bits of skb->extensions (alike what _skb_refdst is doing with the
> SKB_DST_NOREF flag).

I thought I'd start with a simpler approach where allocation type 
is stored in the object itself, to limit the negative reactions :P
We could indeed save a cache miss (I think it'd be actually one fewer
miss than the current implementation, because most cases must end 
up looking at the skb_ext, f.e. to read the refcount. The fact that
SHARD_NOREF implies refcnt == 1 can save us reading from skb_ext).